package benchmark_test

import (
	"fmt"
	"math"

	"testing"
)

//date &&  go test -v -run BenchmarkHello -bench=BenchmarkHello   -benchtime=3s   -benchmem && date

func BenchmarkHello(b *testing.B) {
	b.Log(b.N)

	//b.Logf("begin time: %s \n", time.Now())

	b.ResetTimer()
	for i := 0; i < b.N; i++ {
		//b.Logf("idx %d time: %s \n", i, time.Now())
		fmt.Sprintf("hello")
	}

	//b.StopTimer()
	//b.Logf("end time: %s \n", time.Now())
}

func BenchmarkCalculate(b *testing.B) {
	for i := 0; i < b.N; i++ {
		Calculate(2)
	}
}

// Calculate returns x + 2.
func Calculate(x int) (result int) {
	result = x + 2
	return result
}

func primeNumbers(max int) []int {
	var primes []int

	for i := 2; i < max; i++ {
		isPrime := true

		for j := 2; j <= int(math.Sqrt(float64(i))); j++ {
			if i%j == 0 {
				isPrime = false
				break
			}
		}

		if isPrime {
			primes = append(primes, i)
		}
	}

	return primes
}

var num = 1000

// func BenchmarkPrimeNumbers(b *testing.B) {
// 	for i := 0; i < b.N; i++ {
// 		primeNumbers(num)
// 	}
// }

var table = []struct {
	input int
}{
	{input: 100},
	{input: 1000},
	{input: 74382},
	{input: 382399},
}

func BenchmarkPrimeNumbers(b *testing.B) {
	for _, v := range table {
		b.Run(fmt.Sprintf("input_size_%d", v.input), func(b *testing.B) {
			for i := 0; i < b.N; i++ {
				//primeNumbers(v.input)
				sieveOfEratosthenes(v.input)
			}
		})
	}
}

func sieveOfEratosthenes(max int) []int {
	b := make([]bool, max)

	var primes []int

	for i := 2; i < max; i++ {
		if b[i] {
			continue
		}

		primes = append(primes, i)

		for k := i * i; k < max; k += i {
			b[k] = true
		}
	}

	return primes
}

// main_test.go
func BenchmarkSieveOfErastosthenes(b *testing.B) {
	for _, v := range table {
		b.Run(fmt.Sprintf("input_size_%d", v.input), func(b *testing.B) {
			for i := 0; i < b.N; i++ {
				sieveOfEratosthenes(v.input)
			}
		})
	}
}
